SoSimplifyAction(3)

NAME
SoSimplifyAction - The SoSimplifyAction class is the base class for the simplify action classes.

SYNOPSIS

#include <Inventor/actions/SoSimplifyAction.h>

Inherits SoAction.

Inherited by SoGlobalSimplifyAction, SoReorganizeAction, and SoShapeSimplifyAction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoSimplifyAction (void)
virtual ~SoSimplifyAction (void)
virtual void apply (SoNode *root)
virtual void apply (SoPath *path)
virtual void apply (const SoPathList &pathlist, SbBool obeysrules=FALSE)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void addMethod (const SoType type, SoActionMethod method)
static void enableElement (const SoType type, const int stackindex)
static void initClass (void)

  Protected Member Functions
virtual const SoEnabledElementsList & getEnabledElements (void) const
virtual void beginTraversal (SoNode *node)

  Static Protected Member Functions
static SoEnabledElementsList * getClassEnabledElements (void)
static SoActionMethodList * getClassActionMethods (void)

  Additional Inherited Members

Detailed Description

The SoSimplifyAction class is the base class for the simplify action classes.

Constructor & Destructor Documentation

  SoSimplifyAction::SoSimplifyAction (void)
A constructor.

  SoSimplifyAction::~SoSimplifyAction (void) [virtual]
The destructor.

Member Function Documentation

  SoType SoSimplifyAction::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoAction. This is used for runtime type checking and 'downward' casting.

Implements SoAction.

Reimplemented in SoGlobalSimplifyAction, SoReorganizeAction, and SoShapeSimplifyAction.

  SoType SoSimplifyAction::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  void SoSimplifyAction::addMethod (const SoType type, SoActionMethod method) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  void SoSimplifyAction::enableElement (const SoType type, const int stackindex) [static]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  const SoEnabledElementsList & SoSimplifyAction::getEnabledElements (void) const [protected], [virtual]
Returns list of enabled elements.

Reimplemented from SoAction.

Reimplemented in SoGlobalSimplifyAction, SoReorganizeAction, and SoShapeSimplifyAction.

  SoEnabledElementsList * SoSimplifyAction::getClassEnabledElements (void) [static], [protected]
Returns list of enabled elements for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  SoActionMethodList * SoSimplifyAction::getClassActionMethods (void) [static], [protected]
Returns list of action methods for this class. The enabledElements and methods variables are protected in the original OIV API. This is not such a good idea, since exposed static class member variables is a major grievance with regard to Win32 DLLs. This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

  void SoSimplifyAction::initClass (void) [static]
Initializes the runtime type system for this class, and sets up the enabled elements and action method list.

  void SoSimplifyAction::apply (SoNode * root) [virtual]
Applies the action to the scene graph rooted at root.

Note that you should not apply an action to a node with a zero reference count. The behavior in that case is undefined.

Reimplemented from SoAction.

Reimplemented in SoReorganizeAction.

  void SoSimplifyAction::apply (SoPath * path) [virtual]
Applies the action to the parts of the graph defined by path.

Note that an SoPath will also contain all nodes that may influence e.g. geometry nodes in the path. So for instance applying an SoGLRenderAction on an SoPath will render that path as expected in the view, where geometry will get its materials, textures, and other appearance settings correctly.

If the path ends in an SoGroup node, the action will also traverse the tail node's children.

Reimplemented from SoAction.

Reimplemented in SoReorganizeAction.

  void SoSimplifyAction::apply (const SoPathList & pathlist, SbBool obeysrules = FALSE) [virtual]
Applies action to the graphs defined by pathlist. If obeysrules is set to TRUE, pathlist must obey the following four conditions (which is the case for path lists returned from search actions for non-group nodes and path lists returned from picking actions):

All paths must start at the same head node. All paths must be sorted in traversal order. The paths must be unique. No path can continue through the end point of another path.

See also
    SoAction::apply(SoPath * path)

Reimplemented from SoAction.

Reimplemented in SoReorganizeAction.

  void SoSimplifyAction::beginTraversal (SoNode * node) [protected], [virtual]
This virtual method is called from SoAction::apply(), and is the entry point for the actual scene graph traversal.

It can be overridden to initialize the action at traversal start, for specific initializations in the action subclasses inheriting SoAction.

Default method just calls traverse(), which any overridden implementation of the method must do too (or call SoAction::beginTraversal()) to trigger the scene graph traversal.

Reimplemented from SoAction.

Reimplemented in SoGlobalSimplifyAction, SoReorganizeAction, and SoShapeSimplifyAction.

Author

Generated automatically by Doxygen for Coin from the source code.